--Legal Notice: (C)2007 Altera Corporation. All rights reserved.  Your
--use of Altera Corporation's design tools, logic functions and other
--software and tools, and its AMPP partner logic functions, and any
--output files any of the foregoing (including device programming or
--simulation files), and any associated documentation or information are
--expressly subject to the terms and conditions of the Altera Program
--License Subscription Agreement or other applicable license agreement,
--including, without limitation, that your use is for the sole purpose
--of programming logic devices manufactured by Altera and sold by Altera
--or its authorized distributors.  Please refer to the applicable
--agreement for further details.


-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity DM9000A is 
        port (
              -- inputs:
                 signal CLK : IN STD_LOGIC;
                 signal INT : IN STD_LOGIC;
                 signal iCMD : IN STD_LOGIC;
                 signal iCS_n : IN STD_LOGIC;
                 signal iDATA : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal iIORD_n : IN STD_LOGIC;
                 signal iIOWR_n : IN STD_LOGIC;
                 signal iRST_n : IN STD_LOGIC;

              -- outputs:
                 signal CMD : OUT STD_LOGIC;
                 signal CS_n : OUT STD_LOGIC;
                 signal IORD_n : OUT STD_LOGIC;
                 signal IOWR_n : INOUT STD_LOGIC;
                 signal RST_n : OUT STD_LOGIC;
                 signal data : INOUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal oDATA : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal oINT : OUT STD_LOGIC
              );
end entity DM9000A;


architecture europa of DM9000A is
component DM9000A_IF is 
           port (
                 -- inputs:
                    signal CLK : IN STD_LOGIC;
                    signal INT : IN STD_LOGIC;
                    signal iCMD : IN STD_LOGIC;
                    signal iCS_n : IN STD_LOGIC;
                    signal iDATA : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal iIORD_n : IN STD_LOGIC;
                    signal iIOWR_n : IN STD_LOGIC;
                    signal iRST_n : IN STD_LOGIC;

                 -- outputs:
                    signal CMD : OUT STD_LOGIC;
                    signal CS_n : OUT STD_LOGIC;
                    signal IORD_n : OUT STD_LOGIC;
                    signal IOWR_n : INOUT STD_LOGIC;
                    signal RST_n : OUT STD_LOGIC;
                    signal data : INOUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal oDATA : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal oINT : OUT STD_LOGIC
                 );
end component DM9000A_IF;

                signal internal_CMD :  STD_LOGIC;
                signal internal_CS_n :  STD_LOGIC;
                signal internal_IORD_n :  STD_LOGIC;
                signal internal_RST_n :  STD_LOGIC;
                signal internal_oDATA :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal internal_oINT :  STD_LOGIC;

begin

  --the_DM9000A_IF, which is an e_instance
  the_DM9000A_IF : DM9000A_IF
    port map(
      CMD => internal_CMD,
      CS_n => internal_CS_n,
      IORD_n => internal_IORD_n,
      IOWR_n => IOWR_n,
      RST_n => internal_RST_n,
      data => data,
      oDATA => internal_oDATA,
      oINT => internal_oINT,
      CLK => CLK,
      INT => INT,
      iCMD => iCMD,
      iCS_n => iCS_n,
      iDATA => iDATA,
      iIORD_n => iIORD_n,
      iIOWR_n => iIOWR_n,
      iRST_n => iRST_n
    );


  --vhdl renameroo for output signals
  CMD <= internal_CMD;
  --vhdl renameroo for output signals
  CS_n <= internal_CS_n;
  --vhdl renameroo for output signals
  IORD_n <= internal_IORD_n;
  --vhdl renameroo for output signals
  RST_n <= internal_RST_n;
  --vhdl renameroo for output signals
  oDATA <= internal_oDATA;
  --vhdl renameroo for output signals
  oINT <= internal_oINT;

end europa;

