--Legal Notice: (C)2007 Altera Corporation. All rights reserved.  Your
--use of Altera Corporation's design tools, logic functions and other
--software and tools, and its AMPP partner logic functions, and any
--output files any of the foregoing (including device programming or
--simulation files), and any associated documentation or information are
--expressly subject to the terms and conditions of the Altera Program
--License Subscription Agreement or other applicable license agreement,
--including, without limitation, that your use is for the sole purpose
--of programming logic devices manufactured by Altera and sold by Altera
--or its authorized distributors.  Please refer to the applicable
--agreement for further details.


-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity SD_Card is 
        port (
              -- inputs:
                 signal CLK : IN STD_LOGIC;
                 signal SD_DET : IN STD_LOGIC;
                 signal SD_MISO : IN STD_LOGIC;
                 signal iCMD : IN STD_LOGIC;
                 signal iCS_n : IN STD_LOGIC;
                 signal iDATA : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal iIORD_n : IN STD_LOGIC;
                 signal iIOWR_n : IN STD_LOGIC;
                 signal iRST_n : IN STD_LOGIC;

              -- outputs:
                 signal SD_CLK : INOUT STD_LOGIC;
                 signal SD_CS_n : OUT STD_LOGIC;
                 signal SD_MOSI : OUT STD_LOGIC;
                 signal oDATA : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
              );
end entity SD_Card;


architecture europa of SD_Card is
component SD_Card_IF is 
           port (
                 -- inputs:
                    signal CLK : IN STD_LOGIC;
                    signal SD_DET : IN STD_LOGIC;
                    signal SD_MISO : IN STD_LOGIC;
                    signal iCMD : IN STD_LOGIC;
                    signal iCS_n : IN STD_LOGIC;
                    signal iDATA : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal iIORD_n : IN STD_LOGIC;
                    signal iIOWR_n : IN STD_LOGIC;
                    signal iRST_n : IN STD_LOGIC;

                 -- outputs:
                    signal SD_CLK : INOUT STD_LOGIC;
                    signal SD_CS_n : OUT STD_LOGIC;
                    signal SD_MOSI : OUT STD_LOGIC;
                    signal oDATA : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component SD_Card_IF;

                signal internal_SD_CS_n :  STD_LOGIC;
                signal internal_SD_MOSI :  STD_LOGIC;
                signal internal_oDATA :  STD_LOGIC_VECTOR (7 DOWNTO 0);

begin

  --the_SD_Card_IF, which is an e_instance
  the_SD_Card_IF : SD_Card_IF
    port map(
      SD_CLK => SD_CLK,
      SD_CS_n => internal_SD_CS_n,
      SD_MOSI => internal_SD_MOSI,
      oDATA => internal_oDATA,
      CLK => CLK,
      SD_DET => SD_DET,
      SD_MISO => SD_MISO,
      iCMD => iCMD,
      iCS_n => iCS_n,
      iDATA => iDATA,
      iIORD_n => iIORD_n,
      iIOWR_n => iIOWR_n,
      iRST_n => iRST_n
    );


  --vhdl renameroo for output signals
  SD_CS_n <= internal_SD_CS_n;
  --vhdl renameroo for output signals
  SD_MOSI <= internal_SD_MOSI;
  --vhdl renameroo for output signals
  oDATA <= internal_oDATA;

end europa;

